<?php



class sllimboCurrencyConverter {



	public function __construct() {

		add_shortcode( 'converter', array( $this, 'shortcode' ) );

	}



	function shortcode() {

		$out = '';

		if ( $rates = $this->rates() ) {

			$jsdir  = SLLIMBO_PLUGIN_DIR . 'js/';
			$jspath = SLLIMBO_PLUGIN_PATH . 'js/';

			wp_enqueue_script(
				'currencies',
				$jsdir . 'currencies.js',
				array( 'jquery' ),
				filemtime( $jspath . 'currencies.js' ),
				true
				);


			$all     = $this->currencies();
			$options = array();

			foreach ( $rates as $code => $rate ) {
				if ( array_key_exists( $code, $all ) ) {
					$options[ $code ] = $all[$code];
				}
			}

			$out = '<div class="box converter cf">';
			$out .= '<h5>Price calculator</h5>';
			$out .= '<div class="selector">';
			$out .= '<select id="sllimbo-currency">';
			$out .= '<option value="">Please choose...</option>';
			foreach ( $options as $code => $name ) {
				$out .= '<option value="' . strtolower( $code ) . '">' . $name . '</option>';
			}
			$out .= '</select>';
			$out .= '</div>';
			$out .= '<div class="rates">';
			foreach ( $options as $code => $name ) {
				$out .= '<span id="rate-' . strtolower( $code ) . '">' . $rates[ $code ] . '</span>';
			}
			$out .= '</div>';
			$out .= '<p class="details">Local prices are a rough guide only, PayPal may use a different rate.</p>';
			$out .= '</div>';

		}

		return $out;

	}



	function currencies( $currency = null ) {

		$currencies = array(
			'AFA' => 'Afghan Afghani',
			'AWG' => 'Aruban Florin',
			'AUD' => 'Australian Dollars',
			'ARS' => 'Argentine Pes',
			'AZN' => 'Azerbaijanian Manat',
			'BSD' => 'Bahamian Dollar',
			'BDT' => 'Bangladeshi Taka',
			'BBD' => 'Barbados Dollar',
			'BYR' => 'Belarussian Rouble',
			'BOB' => 'Bolivian Boliviano',
			'BRL' => 'Brazilian Real',
			'GBP' => 'British Pounds Sterling',
			'BGN' => 'Bulgarian Lev',
			'KHR' => 'Cambodia Riel',
			'CAD' => 'Canadian Dollars',
			'KYD' => 'Cayman Islands Dollar',
			'CLP' => 'Chilean Peso',
			'CNY' => 'Chinese Renminbi Yuan',
			'COP' => 'Colombian Peso',
			'CRC' => 'Costa Rican Colon',
			'HRK' => 'Croatia Kuna',
			'CPY' => 'Cypriot Pounds',
			'CZK' => 'Czech Koruna',
			'DKK' => 'Danish Krone',
			'DOP' => 'Dominican Republic Peso',
			'XCD' => 'East Caribbean Dollar',
			'EGP' => 'Egyptian Pound',
			'ERN' => 'Eritrean Nakfa',
			'EEK' => 'Estonia Kroon',
			'EUR' => 'Euro',
			'GEL' => 'Georgian Lari',
			'GHC' => 'Ghana Cedi',
			'GIP' => 'Gibraltar Pound',
			'GTQ' => 'Guatemala Quetzal',
			'HNL' => 'Honduras Lempira',
			'HKD' => 'Hong Kong Dollars',
			'HUF' => 'Hungary Forint',
			'ISK' => 'Icelandic Krona',
			'INR' => 'Indian Rupee',
			'IDR' => 'Indonesia Rupiah',
			'ILS' => 'Israel Shekel',
			'JMD' => 'Jamaican Dollar',
			'JPY' => 'Japanese yen',
			'KZT' => 'Kazakhstan Tenge',
			'KES' => 'Kenyan Shilling',
			'KWD' => 'Kuwaiti Dinar',
			'LVL' => 'Latvia Lat',
			'LBP' => 'Lebanese Pound',
			'LTL' => 'Lithuania Litas',
			'MOP' => 'Macau Pataca',
			'MKD' => 'Macedonian Denar',
			'MGA' => 'Malagascy Ariary',
			'MYR' => 'Malaysian Ringgit',
			'MTL' => 'Maltese Lira',
			'BAM' => 'Marka',
			'MUR' => 'Mauritius Rupee',
			'MXN' => 'Mexican Pesos',
			'MZM' => 'Mozambique Metical',
			'NPR' => 'Nepalese Rupee',
			'ANG' => 'Netherlands Antilles Guilder',
			'TWD' => 'New Taiwanese Dollars',
			'NZD' => 'New Zealand Dollars',
			'NIO' => 'Nicaragua Cordoba',
			'NGN' => 'Nigeria Naira',
			'KPW' => 'North Korean Won',
			'NOK' => 'Norwegian Krone',
			'OMR' => 'Omani Riyal',
			'PKR' => 'Pakistani Rupee',
			'PYG' => 'Paraguay Guarani',
			'PEN' => 'Peru New Sol',
			'PHP' => 'Philippine Pesos',
			'QAR' => 'Qatari Riyal',
			'RON' => 'Romanian New Leu',
			'RUB' => 'Russian Federation Ruble',
			'SAR' => 'Saudi Riyal',
			'CSD' => 'Serbian Dinar',
			'SCR' => 'Seychelles Rupee',
			'SGD' => 'Singapore Dollars',
			'SKK' => 'Slovak Koruna',
			'SIT' => 'Slovenia Tolar',
			'ZAR' => 'South African Rand',
			'KRW' => 'South Korean Won',
			'LKR' => 'Sri Lankan Rupee',
			'SRD' => 'Surinam Dollar',
			'SEK' => 'Swedish Krona',
			'CHF' => 'Swiss Francs',
			'TZS' => 'Tanzanian Shilling',
			'THB' => 'Thai Baht',
			'TTD' => 'Trinidad and Tobago Dollar',
			'TRY' => 'Turkish New Lira',
			'AED' => 'UAE Dirham',
			'USD' => 'US Dollars',
			'UGX' => 'Ugandian Shilling',
			'UAH' => 'Ukraine Hryvna',
			'UYU' => 'Uruguayan Peso',
			'UZS' => 'Uzbekistani Som',
			'VEB' => 'Venezuela Bolivar',
			'VND' => 'Vietnam Dong',
			'AMK' => 'Zambian Kwacha',
			'ZWD' => 'Zimbabwe Dollar'
			);

		return $currencies;

	}



	/**
	 * Use the openexchangerates.org API to calculate the cost in various currencies.
	 * Because we're using the limited free API, we cache the results in a transient.
	 *
	 * @return string list of prices in different currencies
	 */
	function rates() {

		$transient = 'sllimbo-rates';
		$timeout   = 14400; // 4hrs

		if ( false === $return = get_transient( $transient ) ) {

			$return   = array();
			$url      = 'http://openexchangerates.org/api/latest.json';
			$params   = array( 'app_id' => '5dd2836a378a437a8f20d1b680240421' );
			$get      = add_query_arg( $params, $url );
			$response = wp_remote_get( $get );

			if ( !is_wp_error( $response ) and 200 == wp_remote_retrieve_response_code( $response ) ) {

				$body  = wp_remote_retrieve_body( $response );
				$stuff = json_decode( $body, true );
				$rates = $stuff['rates'];

				$base = $rates['GBP'];
				$cost = get_site_preference( 'cost' );

				foreach ( $this->currencies() as $code => $name ) {
					if ( array_key_exists( $code, $rates ) and 'GBP' != $code ) {
						$return[ $code ] = number_format( $cost * ( $rates[$code] / $base ), 2 );
					}
				}

			}

			if ( ! empty( $return ) ) {
				if ( defined( 'WP_LOCAL_DEV' ) and WP_LOCAL_DEV ) {
					$timeout = 5;
				}
				set_transient( $transient, $return, $transient );
			}

		}

		return $return;

	}



}



$sllimbo_currency_converter = new sllimboCurrencyConverter;



?>