<?php



/*
	---------------------------
	gravity forms customisation
	---------------------------
*/



class sllimboForms {



	function __construct() {

		$this->signup_form  = 1;
		$this->profile_form = 2;

		add_action( 'gform_paypal_post_ipn',                        array( $this, 'handle_ipn' ), 10, 4 );
		add_action( 'gform_post_submission_' . $this->profile_form, array( $this, 'update_user_details' ), 10, 2 );
		add_action( 'gform_user_registered',                        array( $this, 'signup_notifications' ), 10, 4 );

		add_filter( 'gform_validation_' . $this->profile_form,      array( $this, 'validate_user_details' ) );
		add_filter( 'gform_validation_message',                     array( $this, 'validation_message' ), 10, 2 );
		add_filter( 'gform_field_value_sllimbocost',                array( $this, 'populate_cost' ) );
		add_filter( 'gform_field_value_sllimboqty',                 array( $this, 'populate_quantity' ) );
		add_filter( 'gform_field_value_sllimboname',                array( $this, 'populate_name' ) );
		add_filter( 'gform_field_value_sllimboemail',               array( $this, 'populate_email' ) );
		add_filter( 'gform_field_value_sllimbouserid',              array( $this, 'populate_user_id' ) );
		add_filter( 'gform_field_value_sllimbocountry',             array( $this, 'populate_country' ) );

	}



	function validation_message( $message, $form ) {

		$message = "<div class='validation_error'>Sorry, there is a problem with your subscription.<br>Please check the error message(s) below, then try again.</div>";

		return $message;

	}



	function signup_notifications( $user_id, $config, $entry, $password ) {

		$user = new WP_User( $user_id );

		$user_login   = stripslashes( $user->user_login );
		$user_name    = stripslashes( $user->display_name );
		$user_email   = stripslashes( $user->user_email );
		$user_country = stripslashes( $entry['5'] );
		$user_country = ( $user_country ? $user_country : 'Not specified' );

		$blogurl  = wp_specialchars_decode( site_url(), ENT_QUOTES );

		$message  = 'Dear ' . $user_name . ',' . "\r\n\r\n";
		$message .= 'Thank you for subscribing to sllimbo.com!' . "\r\n\r\n";
		$message .= 'Here are your account details.' . "\r\n\r\n";
		$message .= '--------------------------------------------------------------------' . "\r\n";
		$message .= sprintf( 'Your username: %s', $user_login ) . "\r\n";
		$message .= sprintf( 'Your password: %s', $password ) . "\r\n";
		$message .= sprintf( 'Your membership number: %s', $user_id ) . "\r\n";
		$message .= '--------------------------------------------------------------------' . "\r\n\r\n";
		$message .= 'Please keep these details safe and do not pass them on to anybody else. We will never ask you for your password, either in an email or on the telephone, you should never give it to anyone who asks for it.' . "\r\n\r\n";
		$message .= sprintf( 'You can log in to view the latest articles and to browse the archive by visiting %s and clicking the "Log in" button at the top of the page', $blogurl ) . "\r\n\r\n";
		$message .= sprintf(
			'Please quote your membership number (%s) when contacting us about your membership so we can quickly find your details. You can update any of your details at %s. You can also view your payment history there. We will send you a confirmation email each time we receive your monthly payment from PayPal.' . "\r\n\r\n",
			$user_id,
			wp_specialchars_decode( get_permalink( 101 ), ENT_QUOTES )
			);

		$message .= 'Best Wishes,' . "\r\n" . 'sllimbo.com' . "\r\n" . "--" . "\r\n" . $blogurl . "\r\n";

		$subject = 'Welcome to sllimbo';

		wp_mail( $user_email, $subject, $message, self::headers() );

		$admin_message  = 'You have a new subscriber!' . "\r\n\r\n";
		$admin_message .= '--------------------------------------------------------------------' . "\r\n";
		$admin_message .= sprintf( 'Name: %s', $user_name ) . "\r\n";
		$admin_message .= sprintf( 'Username: %s', $user_login ) . "\r\n";
		$admin_message .= sprintf( 'Country: %s', $user_country ) . "\r\n";
		$admin_message .= sprintf( 'Membership number: %s', $user_id ) . "\r\n";
		$admin_message .= '--------------------------------------------------------------------' . "\r\n\r\n";

		$admin_subject = 'New sllimbo subscriber';

		$admin_email = get_site_preference( 'email' );

		wp_mail( $admin_email, $admin_subject, $admin_message, self::headers( $user_email, $user_name ) );
		wp_mail( 'simon@lumpylemon.co.uk', $admin_subject, $admin_message, self::headers( $user_email, $user_name ) );

	}



	function headers( $email = null, $name = null ) {

		$from_email = ( $email ? $email : get_site_preference( 'email' ) );
		$from_email = stripslashes( $from_email );
		$site_name  = ( $name ? $name : get_bloginfo( 'name' ) );

		return 'From: ' . $site_name . ' <' . $from_email . '>' . "\r\n";

	}



	function populate_cost( $value ) {

		return get_site_preference( 'cost' );

	}



	function populate_quantity( $value ) {

		return 1;

	}



	function populate_name( $value ) {

		global $current_user;

		get_currentuserinfo();

		return $current_user->display_name;

	}



	function populate_email( $value ) {

		global $current_user;

		get_currentuserinfo();

		return $current_user->user_email;

	}



	function populate_user_id( $value ) {

		global $current_user;

		get_currentuserinfo();

		return $current_user->ID;

	}



	function populate_country( $value ) {

		global $current_user;

		get_currentuserinfo();

		return get_user_meta( $current_user->ID, 'sllimbo-country', true );

	}



	function update_user_details( $entry, $form ) {

		global $current_user;

		get_currentuserinfo();
		$user_id = $current_user->ID;

		$name     = $entry['2'];
		$email    = $entry['3'];
		$password = $entry['4'];

		$userdata = array(
			'ID'           => $user_id,
			'user_email'   => $email,
			'display_name' => $name,
			'first_name'   => $name
			);

		if ( $password ) {
			$userdata['user_pass'] = $password;
		}

		wp_update_user( $userdata );

		$meta = array(
			'country' => $entry['5'],
			);

		foreach ( $meta as $key => $data ) {
			$key = 'sllimbo-' . $key;
			delete_user_meta( $user_id, $key );
			if ( $data ) {
				update_user_meta( $user_id, $key, $data );
			}
		}

	}



	function validate_user_details( $validation_result ) {

		global $current_user;

		get_currentuserinfo();
		$user_id = $current_user->ID;

		$form           = $validation_result['form'];
		$entry          = self::convert_post_to_entry();
		$email_field    = 3;
		$password_field = 4;
		$email          = $entry[ $email_field ];
		$password       = $entry[ $password_field ];

		if ( $id = email_exists( $email ) and $id != $user_id ) {
			$form = self::add_validation_failure( $email_field, $form, 'Email address already in use' );
		}

		if ( false !== strpos( $password, "\\" ) ) {
			$form = self::add_validation_failure( $password_field, $form, 'Passwords cannot contain the character "\"' );
		}

		$validation_result["is_valid"] = self::is_form_valid( $form );
		$validation_result["form"]     = $form;

		return $validation_result;

	}



	function type( $type ) {

		$types = array(
			'subscr_payment_start' => 'PayPal subscription started',
			'subscr_payment_made'  => 'PayPal subscription payment',
			'subscr_cancel'        => 'PayPal subscription cancelled',
			'subscr_eot'           => 'PayPal subscription expired',
			'subscr_failed'        => 'PayPal subscription sign-up failed'
			);

		if ( array_key_exists( $type, $types ) ) {
			return $types[$type];
		}

		return false;

	}



	function handle_ipn( $ipn_post, $entry, $config, $cancel ) {

		if ( $cancel )
			return;

		$type = strtolower( $ipn_post['txn_type'] );

		if ( 'subscr_signup' == $type )
			return;

		$id = $ipn_post['txn_id'];

		self::create_payment( $type, $id, $entry, $config );

	}



	function create_payment( $type, $id, $entry, $config ) {

		$meta = array();

		$username                = $entry[1];
		$user                    = get_user_by( 'login', $username );
		$meta['subscriber-id']   = $user->ID;

		$meta['transaction-id']  = $id;

		if ( 'subscr_payment' == $type ) {
			if ( 'Active' != $entry['payment_status'] ) {
				$type = 'subscr_payment_start';
			} else {
				$type = 'subscr_payment_made';
			}
		}

		// cancellations seem to be sent by PayPal multiple times,
		// so we need a flag to prevent customer getting bombarded with emails
		if ( 'subscr_cancel' == $type and get_user_meta( $user->ID, 'cancellation-processed', true ) )
			return;

		$post_data                 = array();
		$post_data['post_type']    = 'payment';
		$post_data['post_author']  = 1;
		$post_data['post_title']   = $meta['subscriber-id'] . ' ' . $user->display_name;
		// $post_data['post_content'] = $post_data['post_title'] . ' ' . $meta['transaction-id'];
		$post_data['post_content'] = $type . "\r\n" . $id . "\r\n" . print_r( $entry, true );
		$post_data['post_status']  = 'publish';

		if ( false !== strpos( $type, 'subscr_payment' ) ) {
			$meta['amount']          = $entry['6.2'];
			$post_data['post_title'] = $user->display_name . ' ' . $meta['amount'];
		}

		$post_id = wp_insert_post( $post_data );

		if ( ! is_wp_error( $post_id ) ) {
			foreach ( $meta as $key => $value ) {
				update_post_meta( $post_id, 'sllimbo-payment-' . $key, $value );
			}
			if ( $type_long = self::type( $type ) ) {
				wp_set_post_terms( $post_id, $type_long, 'transaction-type' );
			}
			wp_set_post_terms( $post_id, 'PayPal', 'method' );
			add_user_meta( $user->ID, 'payment', $post_id, false );
			self::payment_notification( $user->ID, $post_id, $type );
			if ( 'subscr_cancel' == $type ) {
				add_user_meta( $user->ID, 'cancellation-processed', 1 );
			}
		}

	}



	function payment_notification( $user_id, $payment_id, $type ) {

		$user = new WP_User( $user_id );

		$user_name    = stripslashes( $user->display_name );
		$user_email   = stripslashes( $user->user_email );

		$blogurl  = wp_specialchars_decode( site_url(), ENT_QUOTES );

		$message  = 'Dear ' . $user_name . ',' . "\r\n\r\n";

		if ( 'subscr_cancel' == $type ) {

			$subject = 'sllimbo.com subscription cancelled';

			$message .= 'Your sllimbo.com subscription has been cancelled.' . "\r\n\r\n";
			$message .= 'We\'re sorry to see you go, please do get in touch if you\'d like to give us any feedback about the website.' . "\r\n\r\n";
			$message .= sprintf(
				'You can still view the regularly updated free articles at %s' . "\r\n\r\n",
				wp_specialchars_decode( get_permalink( 114 ), ENT_QUOTES )
				);

			$admin_subject = 'sllimbo subscription cancellation';

			$admin_message = 'A sllimbo.com subscription has been cancelled:' . "\r\n\r\n";
			$admin_message .= '--------------------------------------------------------------------' . "\r\n";
			$admin_message .= sprintf( 'Name: %s', $user_name ) . "\r\n";
			$admin_message .= sprintf( 'Email: %s', $user_email ) . "\r\n";
			$admin_message .= sprintf( 'Membership number: %s', $user_id ) . "\r\n";
			$admin_message .= '--------------------------------------------------------------------' . "\r\n\r\n";

		} else {

			$subject = 'Thank you for your payment to sllimbo';

			$message .= 'Thank you for your payment to sllimbo.com!' . "\r\n\r\n";
			$message .= 'Here are the details.' . "\r\n\r\n";
			$message .= '--------------------------------------------------------------------' . "\r\n";
			$message .= sprintf( 'Date: %s', get_the_time( get_option( 'date_format' ), $payment_id ) ) . "\r\n";
			$message .= sprintf( 'Amount: %s', get_post_meta( $payment_id, 'sllimbo-payment-amount', true ) ) . "\r\n";
			$message .= sprintf( 'PayPal transaction ID: %s', get_post_meta( $payment_id, 'sllimbo-payment-transaction-id', true ) ) . "\r\n";
			$message .= '--------------------------------------------------------------------' . "\r\n\r\n";
			$message .= sprintf(
				'You can log in to view the latest articles and to browse the archive by visiting %s and clicking the "Log in" button at the top of the page' . "\r\n\r\n",
				$blogurl
				);
			$message .= sprintf(
				'You can view a history of all your payments on your account page: %s' . "\r\n\r\n",
				wp_specialchars_decode( get_permalink( 101 ), ENT_QUOTES )
				);
			$message .= sprintf(
				'If you no longer wish to subscribe to sllimbo, please visit %s and cancel your subscription.' . "\r\n\r\n",
				wp_specialchars_decode( 'http://paypal.com', ENT_QUOTES )
				);

			$admin_subject = 'Subscription payment received';

			$admin_message = 'sllimbo.com subscription payment received:' . "\r\n\r\n";
			$admin_message .= '--------------------------------------------------------------------' . "\r\n";
			$admin_message .= sprintf( 'Name: %s', $user_name ) . "\r\n";
			$admin_message .= sprintf( 'Email: %s', $user_email ) . "\r\n";
			$admin_message .= sprintf( 'Membership number: %s', $user_id ) . "\r\n";
			$admin_message .= sprintf( 'Date: %s', get_the_time( get_option( 'date_format' ), $payment_id ) ) . "\r\n";
			$admin_message .= sprintf( 'Amount: %s', get_post_meta( $payment_id, 'sllimbo-payment-amount', true ) ) . "\r\n";
			$admin_message .= sprintf( 'PayPal transaction ID: %s', get_post_meta( $payment_id, 'sllimbo-payment-transaction-id', true ) ) . "\r\n";
			$admin_message .= '--------------------------------------------------------------------' . "\r\n\r\n";

		}

		$message .= sprintf(
			'Please quote your membership number (%s) when contacting us about your membership so we can quickly find your details.' . "\r\n\r\n",
			$user_id
			);

		$message .= 'Best Wishes,' . "\r\n" . 'sllimbo.com' . "\r\n" . "--" . "\r\n" . $blogurl . "\r\n";

		$admin_message .= sprintf(
			'You can view all payments at %s' . "\r\n\r\n",
			wp_specialchars_decode( admin_url( 'edit.php?post_type=payment' ), ENT_QUOTES )
			);

		$admin_email = get_site_preference( 'email' );

		wp_mail( $user_email, $subject, $message, self::headers() );
		wp_mail( $admin_email, $admin_subject, $admin_message, self::headers( $user_email, $user_name ) );
		wp_mail( 'simon@lumpylemon.co.uk', $admin_subject, $admin_message, self::headers( $user_email, $user_name ) );

	}



	private static function convert_post_to_entry() {

		$entry = array();

		foreach($_POST as $key => $value){

			$id = str_replace('_', '.', str_replace('input_', '', $key));
			$entry[$id] = $value;

		}

		return $entry;

	}



	private static function is_form_valid( $form ) {

		foreach ( $form['fields'] as $field ) {
			if ( $field['failed_validation'] == true ) {
				return false;
			}
		}

		return true;

	}



	public static function add_validation_failure( $field_id, $form, $message = "This field does not validate." ) {

		if ( is_numeric( $field_id ) ) {
			$field_id = intval( $field_id );
		}

		$field_count = count( $form['fields'] );

		for ( $i = 0; $i < $field_count; $i++ ) {
			if ( $form['fields'][$i]['id'] == $field_id ) {
				$form["fields"][$i]["failed_validation"]  = true;
				$form["fields"][$i]["validation_message"] = $message;
			}
		}

		return $form;

	}



}



$sllimbo_forms = new sllimboForms;



?>