<?php



class sllimboFrontEnd {



	public function __construct() {

		add_action( 'wp_head',          array( $this, 'fonts'       ) );
		add_action( 'wp_head',          array( $this, 'favicon'        ) );
		// add_action( 'wp_head',          array( $this, 'facebook'       ) );

		// load styles & javascript
		add_action( 'wp_print_scripts', array( $this, 'print_scripts'  ) );
		// add_filter( 'wp_footer',        array( $this, 'footer_script' ) );

		// add_filter( 'pre_get_posts',  array( $this, 'posts_per_page' ) );
		add_filter( 'body_class',     array( $this, 'body_classes' ) );
		// add_filter( 'page_css_class', array( $this, 'page_list_classes' ), 10, 5 );
		// add_filter( 'the_excerpt',    array( $this, 'remove_toc' ) );
		add_filter( 'excerpt_length',    array( $this, 'excerpt_length' ) );
		add_filter( 'excerpt_more',    array( $this, 'excerpt_more' ) );

		add_filter( 'the_title', array( $this, 'homepage_title' ), 10, 2 );
		add_filter( 'the_content', array( $this, 'show_definitions' ) );
		add_filter( 'the_excerpt', 'do_shortcode' );

		add_filter( 'template_include', array( $this, 'protect_content' ), 999 );

		remove_action( 'wp_head', 'adjacent_posts_rel_link_wp_head' );
		remove_action( 'wp_head', 'index_rel_link'                  );
		remove_action( 'wp_head', 'rsd_link'                        );
		remove_action( 'wp_head', 'wlwmanifest_link'                );

	}



	function fonts() {

		echo '<link href="http://fonts.googleapis.com/css?family=Open+Sans:600,700,800" rel="stylesheet" type="text/css">' . "\n";

	}



	function favicon() {

		echo '<link rel="shortcut icon" href="' . site_url( '/favicon.ico' ) . '" type="image/x-icon">' . "\n";

	}



	function facebook() {

		if ( is_admin() )
			return;

		global $post, $wp_the_query;

		$fb_pic = false;

		if ( is_single() ) {
			$fb_pic_src = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ) );
			$fb_pic = $fb_pic_src[0];
		}
		if ( ! $fb_pic ) {
			$fb_pic = get_bloginfo( 'stylesheet_directory' ) . '/i/sllimbo-logo-facebook.png';
		}
		echo '<meta property="og:image" content="' . $fb_pic . '">' . "\n";

		if ( is_single() or ( is_page() and !is_page( get_option( 'page_on_front' ) ) ) ) {
			$desc = wp_trim_words( wp_strip_all_tags( do_shortcode( $post->post_content ) ), 25 );
		} else {
			$desc = get_bloginfo( 'description', 'display' );
		}
		echo '<meta property="og:description" content="' . $desc . '">' . "\n";

		if ( is_singular() and ( $id = $wp_the_query->get_queried_object_id() ) ) {
			echo '<meta property="og:url" content="' . get_permalink( $id ) . '">' . "\n";
		}

	}



	function print_scripts() {

		global $pagenow;

		$jsdir  = SLLIMBO_PLUGIN_DIR . 'js/';
		$jspath = SLLIMBO_PLUGIN_PATH . 'js/';

		wp_enqueue_script( 'jquery' );

		// wp_enqueue_script(
		// 	'sllimbo',
		// 	$jsdir . 'sllimbo.js',
		// 	array( 'jquery' ),
		// 	filemtime( $jspath . 'sllimbo.js' ),
		// 	true
		// 	);

		if ( is_single() ) {
			wp_enqueue_script(
				'scrollto',
				$jsdir . 'scrollto.js',
				array( 'jquery' ),
				filemtime( $jspath . 'scrollto.js' ),
				true
				);
		}

		// wp_enqueue_script(
		// 	'flexslider',
		// 	$jsdir . 'jquery.flexslider-min.js',
		// 	array( 'jquery' ),
		// 	filemtime( $jspath . 'jquery.flexslider-min.js' ),
		// 	true
		// 	);

	}



	function posts_per_page( $query ) {

		if ( isset( $query->query_vars['post_type'] ) ) {

			switch ( $query->query_vars['post_type'] ) {

				case 'product' :
					$query->query_vars['posts_per_page'] = 20;
				break;

			}

		}

		return $query;

	}



	function body_classes( $classes ) {

		$classes[] = 'no-customize-support';

		return $classes;

	}



	function page_list_classes( $classes, $page, $depth, $args, $current_page ) {

		global $post;

		$unset = false;

		switch ( $post->post_type ) {

			case 'product':

				if ( 31 == $page->ID ) {
					if ( is_post_type_archive( 'product' ) ) {
						$classes[] = 'current_page_item';
					} else if ( is_singular( 'product' ) ) {
						$classes[] = 'current_page_parent';
					}
				}

				$unset = true;

			break;

			case 'document':

				if ( 105 == $page->ID ) {
					$classes[] = 'current_page_parent';
				}

				$unset = true;

			break;

		}

		if ( $unset ) {

			if ( 22 == $page->ID ) {
				foreach ( $classes as $key => $class ) {
					if ( 'current_page_item' == $class or 'current_page_parent' == $class ) {
						unset( $classes[$key] );
					}
				}
			}

		}

		return $classes;

	}



	function remove_toc( $excerpt ) {

		return str_replace( '<p>Contents ', '<p>', $excerpt );

	}



	function excerpt_length( $len ) {

		return 20;

	}



	function excerpt_more( $more ) {

		return '&hellip;';

	}



	function homepage_title( $title, $page_id ) {

		if ( !is_admin() and 2 == $page_id and is_user_logged_in() ) {
			$title = 'Latest';
		}

		return $title;

	}



	function show_definitions( $content ) {

		if ( ! is_single() )
			return $content;

		if ( ! $phrases = sllimbo::custom( 'phrases' ) )
			return $content;

		$add = '<div class="box sllimbo-defs cf">';
		$add .= '<h5 class="sllimbo-defs-title">Comments</h5>';

		foreach ( $phrases as $phrase ) {

			$term_link = sanitize_title_with_dashes( $phrase['term'] );

			$add .= sprintf(
						'<h6 class="sllimbo-def-title" id="sllimbo-def-%s"><a href="#sllimbo-phrase-%s" class="sllimbo-phrase-back-link" title="Go to &quot;%s&quot; in the article">%s</a></h6>',
						$term_link,
						$term_link,
						$phrase['term'],
						( $phrase['alt'] ? $phrase['alt'] : $phrase['term'] )
						);

			$add .= sprintf( '<p>%s', nl2br( $phrase['def'] ) );

			if ( isset( $phrase['synonym'] ) ) {
				$add .= sprintf( '<br><em>Also:</em> %s', $phrase['synonym'] );
			}

			$add .= '</p>';

		}

		$add .= '</div>';

		return $content . $add;

	}



	function protect_content( $template ) {

		if ( !is_user_logged_in() and ( is_home() or is_archive() or is_search() or ( is_page() and sllimbo::custom( 'logged-in-only' ) ) ) ) {
			$template = locate_template( array( 'page-login-required.php' ) );
		}

		if ( is_single() and !current_user_can( 'access_articles' ) and !sllimbo::custom( 'free' ) ) {
			$template = locate_template( array( 'single-no-access.php' ) );
		}

		if ( is_page( 2 ) ) {
			if ( is_user_logged_in() ) {
				$template = locate_template( array( 'home-logged-in.php' ) );
			} else {
				$template = locate_template( array( 'home-logged-out.php' ) );
			}

		}

		if ( is_user_logged_in() and is_page( 101 ) ) {
			$template = locate_template( array( 'account.php' ) );
		}

		if ( is_page( 114 ) ) {
			$template = locate_template( array( 'free-articles.php' ) );
		}

		return $template;

	}



}



global $sllimbo_front_end;

$sllimbo_front_end = new sllimboFrontEnd;



?>