<?php



class sllimbo {



	function custom( $key, $args = array() ) {

		$defaults = array(
			'post_id' => null,
			'prefix'  => 'sllimbo-'
		);

		$r = wp_parse_args( $args, $defaults );
		extract( $r, EXTR_SKIP );

		$post = get_post( $post_id );
		$key  = $prefix . $key;
		$data = get_post_meta( $post->ID, $key, true );

		if ( '' === $data )
			$data = false;

		return $data;

	}



	function stylesheets( $print = false ) {

		$file = 'style.css';
		$href = add_query_arg(
						'v',
						filemtime( locate_template( $file ) ),
						get_stylesheet_directory_uri() . '/' . $file
						);

		echo '<link type="text/css" rel="stylesheet" media="all" href="' . $href . '">' . "\n";

		if ( $print ) {

			$file = 'style-print.css';
			$href = add_query_arg(
							'v',
							filemtime( locate_template( $file ) ),
							get_stylesheet_directory_uri() . '/' . $file
							);

			echo '<link type="text/css" rel="stylesheet" media="print" href="' . $href . '">' . "\n";

		}

	}



	function menu() {

		$args = array(
					'depth'    => 1,
					'echo'     => 0,
					'title_li' => ''
					);

		if ( is_user_logged_in() ) {
			$args['include'] = '2,50,97';
		}

		if ( ! is_user_logged_in() ) {
			$out = '<li class="page-item-home-logged-out"><a href="' . site_url() . '">Home</a></li>';
		}

		if ( is_user_logged_in() ) {
			$out .= wp_list_pages( $args );
			
			$out .= '<li><a href="/subscribe">Subscribe</a></li>';
			
			$out .= '<li><a href="/account">Your Account</a></li>';

		}

		// if ( is_user_logged_in() and !current_user_can( 'edit_posts' ) ) {
		// 	$out .= '<li class="page_item page-item-101"><a href="' . get_permalink( 101 ) . '">Your Account</a></li>';
		// }

		if ( is_user_logged_in() ) {
			$out .= '<li class="page-item-log-in-out"><a href="' . wp_logout_url( home_url( '?loggedout=true' ) ) . '">Log out</a></li>';
		} else {
			$out .= '<li class="page-item-log-in-out"><a href="' . wp_login_url( home_url( '?loggedin=true' ) ) . '">Log in</a></li>';
		}
		
		echo $out;

	}



	function signup_button( $free_link = 'default' ) {

		if ( 'default' == $free_link ) {
			$free_link = '<p class="no-mb small">You are welcome to look at the <a class="light underline" href="' . get_permalink( 114 ) . '">example articles</a>.</p>';
		}

		$out = '<p class="no-mb"><a class="sllimbo-button sllimbo-button-big sllimbo-button-signup" href="' . get_permalink( 90 ) . '" title="Join sllimbo now">Subscribe</a></p>';

		if ( $free_link ) {
			$out .= $free_link;
		}

		return $out;

	}



	function recent_posts_where( $where ) {

		$where .= " AND post_date > '" . date( 'Y-m-d', strtotime( '-28 days' ) ) . "'";

		return $where;

	}



	function get_recent_posts() {

		$args = array(
			'post_type'      => 'post',
			'post_status'    => 'publish',
			'posts_per_page' => -1
			);

		add_filter( 'posts_where', array( $this, 'recent_posts_where' ) );
		$query = new WP_Query( $args );
		remove_filter( 'posts_where', array( $this, 'recent_posts_where' ) );

		return $query;

	}



	function article_count() {

		$transient = 'sllimbo-article-count';

		if ( false === $return = get_transient( $transient ) ) {

			$count = wp_count_posts( 'post' );

			$return = $count->publish;

			if ( defined( 'WP_LOCAL_DEV' ) and WP_LOCAL_DEV ) {
				$timeout = 5;
			}

			set_transient( $transient, $return, $transient );

		}

		return $return;

	}



	function post_count( $name = 'Articles', $singular_name = 'Article' ) {

		$count = self::count( $name, $singular_name );

		$out = '';

		if ( is_array( $count ) ) {
			$out .= '<div class="results-count cf">';
			if ( isset( $count['pages'] ) ) {
				$out .= '<div class="page-count">' . $count['pages'] . '</div>';
			}
			$out .= '<div class="post-count">' . $count['posts'] . '</div>';
			$out .= '</div>';
		}

		echo $out;

	}



	function count( $name = 'Articles', $singular_name = 'Article' ) {

		global $posts_per_page, $paged, $wp_query;

		$numposts = $wp_query->found_posts;

		if ( 0 == $numposts )
			return false;

		$count         = array();
		$name          = strtolower( $name );
		$singular_name = strtolower( $singular_name );

		if ( empty( $paged ) ) {
			$paged = 1;
		}

		$startpost = ( $posts_per_page * $paged ) - $posts_per_page + 1;

		if ( ( $startpost + $posts_per_page - 1 ) >= $numposts ) {
			$endpost = $numposts;
		} else {
			$endpost = $startpost + $posts_per_page - 1;
		}

		$numposts_pretty  = number_format( $numposts );
		$startpost_pretty = number_format( $startpost );
		$endpost_pretty   = number_format( $endpost );

		# Check if there is less than one page of results & alter text to suit
		if ( $numposts > $posts_per_page ) {

			# Multiple pages of results
			$count['posts'] = $startpost_pretty . ' - ' . $endpost_pretty . ' of ' . $numposts_pretty . ' ' . $name;

		} else {

			# Check if there is only a single result & alter text to suit
			if ( $numposts != 1 ) {

				# Single page - multiple results
				$count['posts'] = $numposts_pretty . ' ' . $name;
			} else {

				# Single result
				$count['posts'] = '1 ' . $singular_name;

			}

		}

		$pages = $wp_query->max_num_pages;

		if ( 1 != $pages ) {

			$paged_pretty = number_format( $paged );
			$pages_pretty = number_format( $pages );

			$count['pages'] = 'Page ' . $paged_pretty . ' of ' . $pages_pretty;

		}

		return $count;

	}



	function paginate( $pages = '', $range = 3 ) {

		global $paged;

		$showitems = ( $range * 2 ) + 1;

		if ( empty( $paged ) ) {
			$paged = 1;
		}

		if ( '' == $pages ) {

			global $wp_query;

			$pages = $wp_query->max_num_pages;

			if ( ! $pages ) {
				$pages = 1;
			}

		}

		if ( 1 != $pages ) {

			echo '<div class="pagination">' . "\n";
			echo '<div class="page-links">' . "\n";

			if ( $paged > 2 && $paged > $range + 1 && $showitems < $pages ) {
				echo '<a href="' . get_pagenum_link( 1 ) . '">&laquo; First</a>';
			}

			if ( $paged > 1 && $showitems < $pages ) {
				echo '<a href="' . get_pagenum_link( $paged - 1 ) . '">&lsaquo; Prev</a>';
			}

			for ( $i = 1; $i <= $pages; $i++ ) {
				if ( 1 != $pages && ( ! ( $i >= $paged + $range + 1 || $i <= $paged - $range - 1 ) || $pages <= $showitems ) ) {
					echo ( $paged == $i ) ? '<span class="current">' . $i . '</span>' : '<a href="' . get_pagenum_link( $i ) . '" class="inactive">' . $i . '</a>';
				}
			}

			if ( $paged < $pages && $showitems < $pages ) {
				echo '<a href="' . get_pagenum_link( $paged + 1 ) . '">Next &rsaquo;</a>';
			}

			if ( $paged < $pages - 1 &&  $paged + $range - 1 < $pages && $showitems < $pages ) {
				echo '<a href="' . get_pagenum_link( $pages ) . '">Last &raquo;</a>';
			}

			echo '</div>' . "\n";
			echo '</div>' . "\n";

		}

	}



	function section() {

		global $post;

		switch ( $post->post_type ) {

			// case 'review' :
			// 	$section = 294;
			// break;

			case 'page' :
				if ( 0 == $post->post_parent ) {
					$section = $post->ID;
				} else {
					$section = $post->post_parent;
				}
			break;

		}

		return $section;

	}



	function get_shortlink( $id = null ) {

		$post = get_post( $id );

		return site_url( 'go/' . $post->ID );

	}



	function shortlink( $id = null ) {

		echo sllimbo::get_shortlink( $id );

	}



	function sidebox( $id ) {

		$box = get_post( $id );

		if ( ! $box or is_wp_error( $box ) )
			return;

		echo '<div class="widget">';
			echo '<h6>' . get_the_title( $box->ID ) . '</h6>';
			echo apply_filters( 'the_content', $box->post_content );
		echo '</div>';

	}



	function pages( $parent = false, $title = 'In This Section' ) {

		global $post;

		$exclude_list = '';

		if ( ! $parent ) {
			$parent = self::section();
		}

		$args = array(
					'echo'        => false,
					'child_of'    => $parent,
					'depth'       => 1,
					'title_li'    => '',
					'exclude'     => $exclude_list,
					'sort_column' => 'menu_order'
					);

		$kids = wp_list_pages( $args );

		if ( $kids ) { ?>
			<div class="widget">
				<h5><?php echo $title; ?></h5>
				<ul class="page-list">
					<?php echo $kids; ?>
				</ul>
			</div>
		<?php }

	}



	function num2words( $number ) {

		$hyphen      = '-';
		$conjunction = ' and ';
		$separator   = ', ';
		$negative    = 'negative ';
		$decimal     = ' point ';
		$dictionary  = array(
			0                   => 'zero',
			1                   => 'one',
			2                   => 'two',
			3                   => 'three',
			4                   => 'four',
			5                   => 'five',
			6                   => 'six',
			7                   => 'seven',
			8                   => 'eight',
			9                   => 'nine',
			10                  => 'ten',
			11                  => 'eleven',
			12                  => 'twelve',
			13                  => 'thirteen',
			14                  => 'fourteen',
			15                  => 'fifteen',
			16                  => 'sixteen',
			17                  => 'seventeen',
			18                  => 'eighteen',
			19                  => 'nineteen',
			20                  => 'twenty',
			30                  => 'thirty',
			40                  => 'fourty',
			50                  => 'fifty',
			60                  => 'sixty',
			70                  => 'seventy',
			80                  => 'eighty',
			90                  => 'ninety',
			100                 => 'hundred',
			1000                => 'thousand',
			1000000             => 'million',
			1000000000          => 'billion',
			1000000000000       => 'trillion',
			1000000000000000    => 'quadrillion',
			1000000000000000000 => 'quintillion'
		);

		if ( ! is_numeric( $number ) ) {
			return false;
		}

		if ( ( $number >= 0 and (int) $number < 0 ) or (int) $number < 0 - PHP_INT_MAX ) {
			trigger_error(
				'convert_number_to_words only accepts numbers between -' . PHP_INT_MAX . ' and ' . PHP_INT_MAX,
				E_USER_WARNING
			);
			return false;
		}

		if ( $number < 0 ) {
			return $negative . num2words( abs( $number ) );
		}

		$string = $fraction = null;

		if ( strpos( $number, '.' ) !== false ) {
			list( $number, $fraction ) = explode( '.', $number );
		}

		switch ( true ) {
			case $number < 21:
				$string = $dictionary[$number];
				break;
			case $number < 100:
				$tens   = ( (int) ( $number / 10 ) ) * 10;
				$units  = $number % 10;
				$string = $dictionary[$tens];
				if ( $units ) {
					$string .= $hyphen . $dictionary[$units];
				}
				break;
			case $number < 1000:
				$hundreds  = $number / 100;
				$remainder = $number % 100;
				$string = $dictionary[$hundreds] . ' ' . $dictionary[100];
				if ( $remainder ) {
					$string .= $conjunction . num2words( $remainder );
				}
				break;
			default:
				$baseUnit = pow( 1000, floor( log( $number, 1000 ) ) );
				$numBaseUnits = (int) ( $number / $baseUnit );
				$remainder = $number % $baseUnit;
				$string = num2words( $numBaseUnits ) . ' ' . $dictionary[$baseUnit];
				if ( $remainder ) {
					$string .= $remainder < 100 ? $conjunction : $separator;
					$string .= num2words( $remainder );
				}
				break;
		}

		if ( null !== $fraction and is_numeric( $fraction ) ) {
			$string .= $decimal;
			$words = array();
			foreach ( str_split( (string) $fraction ) as $number ) {
				$words[] = $dictionary[$number];
			}
			$string .= implode( ' ', $words );
		}

		return $string;

	}



	function get_payment_type( $id ) {

		$terms = wp_get_object_terms( $id, 'transaction-type' );

		if ( is_wp_error( $terms ) or empty( $terms ) )
			return;

		$out = array();

		foreach ( $terms as $term ) {
			$out[] = $term->name;
		}

		return implode( '<br>', $out );

	}



}



global $sllimbo;

$sllimbo = new sllimbo;



?>